ScoopParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
ScoopParser Class Referencefinal

the main class to read a Scoop v1 file More...

`#include <ScoopParser.hxx>`

Inheritance diagram for ScoopParser:

## Public Member Functions
| ScoopParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor More...
| ~ScoopParser () final
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false) final
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGDrawingInterface *documentInterface) final
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWGraphicParser
| ~MWAWGraphicParser () override
| destructor More...
virtual void | parse (librevenge::RVNGDrawingInterface *documentInterface)=0
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
virtual bool | checkHeader (MWAWHeader *header, bool strict=false)=0
| virtual function used to check if the document header is correct (or not) More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | createDocument (librevenge::RVNGDrawingInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
bool | readPrintInfo ()
| try to read the print info zone More...
bool | readHeader ()
| try to the header zone More...
bool | readTextZone (ScoopParserInternal::TextZone &tZone)
| try to read the data associated to a text zone: its name, its content, the list of shape which displayed this text More...
bool | readTextZoneParagraph (ScoopParserInternal::Paragraph &para, int id)
| try to read a frame paragraph More...
bool | readFont (MWAWFont &font)
| try to read a font style More...
bool | readParagraph (MWAWParagraph &para, bool define=false)
| try to read a paragraph style More...
bool | readText (MWAWEntry &entry, std::string const &what)
| try to read a text zone More...
bool | readShapesList (std::vector< ScoopParserInternal::Shape > &shapes)
| try to read a list of shape More...
bool | readShape (ScoopParserInternal::Shape &shape, int id)
| try to read a shape More...
bool | readBitmap (MWAWEntry const &entry, MWAWEmbeddedObject &object, bool compressed=true)
| try to read a bitmap More...
bool | send (ScoopParserInternal::Shape const &shape, MWAWVec2i const &decal)
| try to send a shape More...
bool | sendText (long tZoneId, int subZone)
| try to send the text of a text zone More...
bool | sendText (ScoopParserInternal::Paragraph const &paragraph)
| try to send the text corresponding to a paragraph More...
Protected Member Functions inherited from MWAWGraphicParser
| MWAWGraphicParser (MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWGraphicParser (MWAWParserStatePtr const &state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr const &input, MWAWRSRCParserPtr const &rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr const &state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
std::shared_ptr< ScoopParserInternal::State > | m_state
| the state More...

## Friends
class | ScoopParserInternal::SubDocument

## Detailed Description

the main class to read a Scoop v1 file

## Constructor & Destructor Documentation

## ◆ ScoopParser()

ScoopParser::ScoopParser | ( | MWAWInputStreamPtr const & | input,
|  | MWAWRSRCParserPtr const & | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~ScoopParser()

ScoopParser::~ScoopParser | ( |  | ) |
| final

destructor

## Member Function Documentation

## ◆ checkHeader()

bool ScoopParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| finalvirtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void ScoopParser::createDocument | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool ScoopParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ parse()

void ScoopParser::parse | ( | librevenge::RVNGDrawingInterface * | documentInterface | ) |
| finalvirtual

virtual function used to parse the input

Implements MWAWGraphicParser.

## ◆ readBitmap()

bool ScoopParser::readBitmap | ( | MWAWEntry const & | entry,
|  | MWAWEmbeddedObject & | object,
|  | bool | compressed = `true`
| ) |  |
| protected

try to read a bitmap

Referenced by readShape(), and send().

## ◆ readFont()

bool ScoopParser::readFont | ( | MWAWFont & | font | ) |
| protected

try to read a font style

Referenced by readTextZone(), and readTextZoneParagraph().

## ◆ readHeader()

bool ScoopParser::readHeader | ( |  | ) |
| protected

try to the header zone

Referenced by createZones().

## ◆ readParagraph()

bool ScoopParser::readParagraph | ( | MWAWParagraph & | para,
|  | bool | define = `false`
| ) |  |
| protected

try to read a paragraph style

Referenced by readTextZone(), and readTextZoneParagraph().

## ◆ readPrintInfo()

bool ScoopParser::readPrintInfo | ( |  | ) |
| protected

try to read the print info zone

Referenced by readHeader().

## ◆ readShape()

bool ScoopParser::readShape | ( | ScoopParserInternal::Shape & | shape,
|  | int | id
| ) |  |
| protected

try to read a shape

Referenced by readShapesList().

## ◆ readShapesList()

bool ScoopParser::readShapesList | ( | std::vector< ScoopParserInternal::Shape > & | shapes | ) |
| protected

try to read a list of shape

Referenced by createZones(), and readShape().

## ◆ readText()

bool ScoopParser::readText | ( | MWAWEntry & | entry,
|  | std::string const & | what
| ) |  |
| protected

try to read a text zone

Referenced by readParagraph(), readTextZone(), and readTextZoneParagraph().

## ◆ readTextZone()

bool ScoopParser::readTextZone | ( | ScoopParserInternal::TextZone & | tZone | ) |
| protected

try to read the data associated to a text zone: its name, its content, the list of shape which displayed this text

Referenced by createZones().

## ◆ readTextZoneParagraph()

bool ScoopParser::readTextZoneParagraph | ( | ScoopParserInternal::Paragraph & | para,
|  | int | id
| ) |  |
| protected

try to read a frame paragraph

Referenced by readTextZone().

## ◆ send()

bool ScoopParser::send | ( | ScoopParserInternal::Shape const & | shape,
|  | MWAWVec2i const & | decal
| ) |  |
| protected

try to send a shape

Referenced by parse(), and send().

## ◆ sendText() [1/2]

bool ScoopParser::sendText | ( | long | tZoneId,
|  | int | subZone
| ) |  |
| protected

try to send the text of a text zone

Referenced by sendText().

## ◆ sendText() [2/2]

bool ScoopParser::sendText | ( | ScoopParserInternal::Paragraph const & | paragraph | ) |
| protected

try to send the text corresponding to a paragraph

## Friends And Related Function Documentation

## ◆ ScoopParserInternal::SubDocument

friend class ScoopParserInternal::SubDocument
| friend

## Member Data Documentation

## ◆ m_state

std::shared_ptr<ScoopParserInternal::State> ScoopParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), parse(), readHeader(), readParagraph(), readShape(), readTextZone(), and sendText().

The documentation for this class was generated from the following files:

- ScoopParser.hxx
- ScoopParser.cxx